VERSION 5.00
Begin VB.Form WinSeek 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Cerca file"
   ClientHeight    =   4755
   ClientLeft      =   1920
   ClientTop       =   1890
   ClientWidth     =   7935
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000080&
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4755
   ScaleWidth      =   7935
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox Picture2 
      BorderStyle     =   0  'None
      Height          =   3735
      Left            =   360
      ScaleHeight     =   3735
      ScaleWidth      =   7275
      TabIndex        =   8
      Top             =   240
      Visible         =   0   'False
      Width           =   7275
      Begin VB.ListBox lstFoundFiles 
         Height          =   2985
         Left            =   240
         TabIndex        =   11
         Top             =   600
         Width           =   6915
      End
      Begin VB.Label lblCount 
         Caption         =   "0"
         Height          =   255
         Left            =   1380
         TabIndex        =   10
         Top             =   120
         Width           =   1095
      End
      Begin VB.Label lblfound 
         Caption         =   "File trovati:"
         Height          =   255
         Left            =   300
         TabIndex        =   9
         Top             =   120
         Width           =   1095
      End
   End
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'None
      Height          =   3255
      Left            =   360
      ScaleHeight     =   3255
      ScaleWidth      =   7215
      TabIndex        =   2
      Top             =   480
      Width           =   7215
      Begin VB.DriveListBox drvList 
         Height          =   315
         Left            =   3960
         TabIndex        =   7
         Top             =   480
         Width           =   3255
      End
      Begin VB.DirListBox dirList 
         Height          =   1890
         Left            =   3960
         TabIndex        =   6
         Top             =   960
         Width           =   3255
      End
      Begin VB.FileListBox filList 
         Height          =   2430
         Left            =   120
         TabIndex        =   5
         Top             =   480
         Width           =   3735
      End
      Begin VB.TextBox txtSearchSpec 
         Height          =   285
         Left            =   3960
         TabIndex        =   4
         Text            =   "*.*"
         Top             =   120
         Width           =   3255
      End
      Begin VB.Label lblCriteria 
         Caption         =   "C&riteri di ricerca:"
         Height          =   255
         Left            =   420
         TabIndex        =   3
         Top             =   120
         Width           =   1515
      End
   End
   Begin VB.CommandButton cmdSearch 
      BackColor       =   &H00C0C0C0&
      Caption         =   "&Cerca"
      Default         =   -1  'True
      Height          =   480
      Left            =   1200
      TabIndex        =   0
      Top             =   4080
      Width           =   2400
   End
   Begin VB.CommandButton cmdExit 
      BackColor       =   &H00C0C0C0&
      Caption         =   "E&sci"
      Height          =   480
      Left            =   4560
      TabIndex        =   1
      Top             =   4080
      Width           =   2400
   End
End
Attribute VB_Name = "WinSeek"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim SearchFlag As Integer   ' Utilizzato come flag per l'annullamento e altre operazioni.

Private Sub cmdExit_Click()
    If cmdExit.Caption = "E&sci" Then
        End
    Else                    ' Se l'utente sceglie Annulla interrompe la ricerca.
        SearchFlag = False
    End If
End Sub

Private Sub cmdSearch_Click()
' Inizializza la ricerca e quindi esegue una ricerca ricorsiva.
Dim FirstPath As String, DirCount As Integer, NumFiles As Integer
Dim result As Integer
  ' Controlla l'ultima operazione eseguita dall'utente.
    If cmdSearch.Caption = "&Ripristina" Then  ' Se si tratta del ripristino, inizializza e esce.
        ResetSearch
        txtSearchSpec.SetFocus
        Exit Sub
    End If

    ' Aggiorna dirList.Path se  diverso dalla directory corrente
    ' selezionata, altrimenti esegue la ricerca.
    If dirList.Path <> dirList.List(dirList.ListIndex) Then
        dirList.Path = dirList.List(dirList.ListIndex)
        Exit Sub         ' Esce in modo che gli utenti possano dare un'occhiata prima di eseguire la ricerca.
    End If

    ' Continua la ricerca.
    Picture2.Move 0, 0
    Picture1.Visible = False
    Picture2.Visible = True

    cmdExit.Caption = "Annulla"

    filList.Pattern = txtSearchSpec.Text
    FirstPath = dirList.Path
    DirCount = dirList.ListCount

    ' Avvia la ricerca ricorsiva nella directory.
    NumFiles = 0                       ' Reimposta l'indicatore dei file trovati.
    result = DirDiver(FirstPath, DirCount, "")
    filList.Path = dirList.Path
    cmdSearch.Caption = "&Ripristina"
    cmdSearch.SetFocus
    cmdExit.Caption = "E&sci"
End Sub

Private Function DirDiver(NewPath As String, DirCount As Integer, BackUp As String) As Integer
'  Esegue la ricerca in modo ricorsivo nelle directory
'  successive a NewPath nella struttura. NewPath viene
'  cercato in questa ricorsione. BackUp  l'origine della
'  ricorsione. DirCount  il numero di sottodirectory in
'  questa directory.
Static FirstErr As Integer
Dim DirsToPeek As Integer, AbandonSearch As Integer, ind As Integer
Dim OldPath As String, ThePath As String, entry As String
Dim retval As Integer
    SearchFlag = True           ' Imposta il flag in modo che l'utente possa interrompere.
    DirDiver = False            ' Imposta su True se c' un errore.
    retval = DoEvents()         ' Controlla gli eventi (ad esempio, se l'utente sceglie Annulla).
    If SearchFlag = False Then
        DirDiver = True
        Exit Function
    End If
    On Local Error GoTo DirDriverHandler
    DirsToPeek = dirList.ListCount                  ' Quando directory sotto questa?
    Do While DirsToPeek > 0 And SearchFlag = True
        OldPath = dirList.Path                      ' Salva il percorso precedente per la ricorsione successiva.
        dirList.Path = NewPath
        If dirList.ListCount > 0 Then
            ' Passa alla fine del nodo.
            dirList.Path = dirList.List(DirsToPeek - 1)
            AbandonSearch = DirDiver((dirList.Path), DirCount%, OldPath)
        End If
        ' Sale di un livello nella struttura delle directory.
        DirsToPeek = DirsToPeek - 1
        If AbandonSearch = True Then Exit Function
    Loop
    ' Richiama la funzione per l'enumerazione dei file.
    If filList.ListCount Then
        If Len(dirList.Path) <= 3 Then             ' Controlla la presente di caratteri a 2 byte
            ThePath = dirList.Path                 ' Se  il livello principale, non modifica niente...
        Else
            ThePath = dirList.Path + "\"           ' Altrimenti inserisce "\" prima del nome del file.
        End If
        For ind = 0 To filList.ListCount - 1       ' Aggiunge nella casella di riepilogo i file corrispondenti in questa directory.
            entry = ThePath + filList.List(ind)
            lstFoundFiles.AddItem entry
            lblCount.Caption = Str(Val(lblCount.Caption) + 1)
        Next ind
    End If
    If BackUp <> "" Then        ' Se esiste una directory superiore, la sposta.
        dirList.Path = BackUp
    End If
    Exit Function
DirDriverHandler:
    If Err = 7 Then             ' Se si verifica un errore di memoria esaurita, presuppone che la casella sia piena.
        DirDiver = True         ' Crea Msg e imposta il valore di ritorno AbandonSearch.
        MsgBox "La casella di riepilogo  piena. Interruzione della ricerca..."
        Exit Function           ' Si noti che la routine di uscita reimposta Err su 0.
    Else                        ' Altrimenti visualizza un messaggio di errore ed esce.
        MsgBox Error
        End
    End If
End Function

Private Sub DirList_Change()
    ' Aggiorna la casella di riepilogo dei file per sincronizzarla con la casella di riepilogo delle directory.
    filList.Path = dirList.Path
End Sub

Private Sub DirList_LostFocus()
    dirList.Path = dirList.List(dirList.ListIndex)
End Sub

Private Sub DrvList_Change()
    On Error GoTo DriveHandler
    dirList.Path = drvList.Drive
    Exit Sub

DriveHandler:
    drvList.Drive = dirList.Path
    Exit Sub
End Sub

Private Sub Form_Load()
    Picture2.Move 0, 0
    Picture2.Width = WinSeek.ScaleWidth
    Picture2.BackColor = WinSeek.BackColor
    lblCount.BackColor = WinSeek.BackColor
    lblCriteria.BackColor = WinSeek.BackColor
    lblfound.BackColor = WinSeek.BackColor
    Picture1.Move 0, 0
    Picture1.Width = WinSeek.ScaleWidth
    Picture1.BackColor = WinSeek.BackColor
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
Cancel = True ' non permette la chiusura della maschera agendo con la X
End Sub

Private Sub Form_Unload(Cancel As Integer)
    End
End Sub

Private Sub ResetSearch()
    ' Reinizializza prima di iniziare una nuova ricerca.
    lstFoundFiles.Clear
    lblCount.Caption = 0
    SearchFlag = False                  ' Flag che indica che la ricerca  in corso.
    Picture2.Visible = False
    cmdSearch.Caption = "&Cerca"
    cmdExit.Caption = "E&sci"
    Picture1.Visible = True
    dirList.Path = CurDir: drvList.Drive = dirList.Path ' Ripristina il percorso.
End Sub

Private Sub txtSearchSpec_Change()
    ' Aggiorna la casella di riepilogo dei file se l'utente cambia i criteri di ricerca.
    filList.Pattern = txtSearchSpec.Text
End Sub

Private Sub txtSearchSpec_GotFocus()
    txtSearchSpec.SelStart = 0          ' Evidenzia la voce corrente.
    txtSearchSpec.SelLength = Len(txtSearchSpec.Text)
End Sub

